/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *  
 *  Created in 2002
 */

package nu.fw.jeti.backend.roster;


import java.util.List;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.JIDStatus;


/**
  * @author E.S. de Boer
  */

public class ResourceJIDStatus extends SecondaryJIDStatus implements Cloneable
{
	private NormalJIDStatus normalJIDStatus;

	public ResourceJIDStatus(JID jid,NormalJIDStatus normalJIDStatus)
	{
		this.completeJID = jid;
		this.normalJIDStatus = normalJIDStatus;
	}

	void update(JID jid,int show, String status,boolean online)
	{
		this.online = online;
		this.show = show;
		this.status = status;
		this.completeJID = jid;
	}

	public String toString()
	{//jid
		return completeJID.toString();
	}
	
	public JIDStatus normalJIDStatus()
	{
		return normalJIDStatus; 
	}

	public JID getJID(){return normalJIDStatus.getJID();}

	

	public String getNick()
	{
		return normalJIDStatus.getNick();
	}

	public String getType()
	{
		return normalJIDStatus.getType();
	}

	public String getSubscription(){return normalJIDStatus.getSubscription();}

	public String getWaiting()
	{
		return normalJIDStatus.getWaiting();
	}

	public List getGroupsCopy(){return normalJIDStatus.getGroupsCopy();}

	public int groupCount(){return normalJIDStatus.groupCount();}

	public boolean isGroupPresent(String group){return normalJIDStatus.isGroupPresent(group);}

	public int compareTo(Object o)
	{//compare jid
		//if(nickname==null) return -1;
		//return nickname.compareTo(((JIDStatus2)o).nickname);
		if(!(o instanceof ResourceJIDStatus)) return normalJIDStatus.compareTo(this,(JIDStatus)o);
		ResourceJIDStatus resourceJIDStatus = (ResourceJIDStatus)o;
		if(this.equals(resourceJIDStatus)) return 0;
		int result = (normalJIDStatus.compareTo(this,resourceJIDStatus));
		if(result == 0)
		{
			return completeJID.getResource().compareTo(resourceJIDStatus.getCompleteJID().getResource());
		}
		return result;
	}



	public Object clone()
	{//shallow copy
		try
		{
			return super.clone();
		}
		catch (CloneNotSupportedException ex)
		{
			ex.printStackTrace();
			return null;
		}
	}
}

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
